;*****************************************************************************
;* HASM64                                                                    *
;*****************************************************************************

;*****************************************************************************
;* File name:     startup.inc                                                *
;* Created:       2001-06-01 by Hampa Hug <hhug@student.ethz.ch>             *
;* Last modified: 2002-08-27 by Hampa Hug <hhug@student.ethz.ch>             *
;* Copyright:     (C) 2001-2002 by Hampa Hug <hhug@student.ethz.ch>          *
;*****************************************************************************

;*****************************************************************************
;* This program is free software. You can redistribute it and / or modify it *
;* under the terms of the GNU General Public License version 2 as  published *
;* by the Free Software Foundation.                                          *
;*                                                                           *
;* This program is distributed in the hope  that  it  will  be  useful,  but *
;* WITHOUT  ANY   WARRANTY,   without   even   the   implied   warranty   of *
;* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  General *
;* Public License for more details.                                          *
;*****************************************************************************

; $Id: startup.inc 19 2004-03-24 15:29:56Z hampa $


;**************************************************************************
;* These are BASIC tokens
;**************************************************************************/
BAS_SYS = 0x9e
BAS_END = 0x80
BAS_REM = 0x8f


;**************************************************************************
;* Convert the start offset to decimal
;**************************************************************************/
ORG_DIG1 = (start / 1000) mod 10
ORG_DIG2 = (start / 100) mod 10
ORG_DIG3 = (start / 10) mod 10
ORG_DIG4 = start mod 10


;--------------------------------------------------------------------------

;**************************************************************************
;* The load address
;**************************************************************************/
  db.2   basic_start

basic_start:

line10:
  db.2   line10_end                    ; Pointer to next line
  db.2   10                            ; Line number
  db.1   BAS_REM, " HASM64", 0x00
line10_end:

line20:
  db.2   line20_end                    ; Pointer to next line
  db.2   20                            ; Line number
  db.1   BAS_SYS
  db.1   " "
  db.1   0x30 + ORG_DIG1               ; The start address
  db.1   0x30 + ORG_DIG2
  db.1   0x30 + ORG_DIG3
  db.1   0x30 + ORG_DIG4
  db.1   0x00
line20_end:

line30:
  db.2   line30_end
  db.2   30
  db.1   BAS_END, 0x00
line30_end:

line_last:
  db.2   0x0000                        ; Last line
